/*
 	Copyright (C) 2009, 2010 Free Software Foundation, Inc.
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 3 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

VM_DEFINE_INSTRUCTION(210, over_to_c,    "over-to-c",1,0,0)
{
  int i;
  SCM sf;
  SCM *ssp;

  typedef void (*fast_f)(SCM *, SCM **);
  fast_f f;
  
  i  = FETCH();

  printf("got object %d\n", i);

  sf = OBJECT_REF(i); 

  if(!(SCM_UNPACK(sf) & (scm_t_bits) 2)) goto check_for_c_fkn;
  f = (fast_f) (SCM_UNPACK(sf) & ~ (scm_t_bits) 2);
 
  printf("got the compiled function adress in %x\n", (scm_t_bits) f);
  
 run_c_fkn:
  printf("run cfkn\n");
  ssp = sp;
  (*f)(fp,&ssp);
  printf("function returned sp[0] = %x sp[-1] = %x\n",(scm_t_bits) ssp[0], (scm_t_bits) ssp[-1]);
  sp = ssp;
  if(!(SCM_UNPACK(*sp) >> 4)) goto c_fkn_return;
  printf("got a new function\n");
  sp --;
  sf = fp[-1];
  if(!(SCM_UNPACK(sf) & 2)) goto check_for_c_fkn;
  f = (fast_f) (SCM_UNPACK(sf) & ~2);
  goto run_c_fkn;


 c_fkn_return:
  printf("got a return\n");
  sp--;
  if(SCM_UNPACK(sp[1]) == 2) goto vm_return;
  
 check_for_c_fkn:
  {
    printf("check for c fkn\n");

    if(SCM_SYMBOLP(sf))
      {
	printf("Will get the function variable from symbol");

	if (!SCM_VARIABLEP (sf)) 
	  {
	    printf("Not a variablep\n");
	    SYNC_REGISTER ();
	    sf = resolve_variable (sf, scm_program_module (program));
	    if (!VARIABLE_BOUNDP (sf))
	      {
		printf("Variable is not bound!!\n");
		NEXT;
	      }
	  }
	printf("ref the variable and put it into the object slot");
	sf = VARIABLE_REF(sf);
	OBJECT_SET(i,sf);
	
	printf("got(%x)\n",(scm_t_bits) sf);
	f = (fast_f) (SCM_UNPACK(sf) & ~ (scm_t_bits) 2);
	goto run_c_fkn;
      }
    NEXT;
  }
 
    
  printf("sf is not a symbol leave the fastpath\n");
  NEXT;
}
